//
//  main.cpp
//  calcTools
//
//  Created by Kristopher Krasnosky on 11/4/13.
//  Copyright (c) 2013 Kristopher Krasnosky. All rights reserved.
//





//#include <iostream>
#include "PFNav.h"


int main(int argc, char **argv)
{
   ros::init(argc, argv, "PFNavNode");

    potentialField myPotentialField;
    PFNav navigator;
    PFNav navigator2;
    
    // preapare some points and add them to the potential field.
    {
      potentialField::attractivePoint mypoint {3.11,0.80,10};
      potentialField::repulsivePoint mypoint2 {1.955,0,5,1};
      potentialField::repulsivePoint mypoint3 {0.8382,0.6,5,1};
      
      myPotentialField.addPoint(mypoint);
      myPotentialField.addPoint(mypoint2);
      myPotentialField.addPoint(mypoint3);
    }
    
    // print out the potential field
    myPotentialField.printPotentialField();

  
    navigator.setPotentialField(myPotentialField);  	// send the potentialField to the navigator
    navigator.setOdom(0,0,0);				// set the odometer to 0
    navigator.spin();					// start running!
    
    //reset the start point 
    {
      potentialField::attractivePoint mypoint {0,0,10};
      myPotentialField.setPoint(0,mypoint);
      myPotentialField.printPotentialField();
    }
    
    navigator.setPotentialField(myPotentialField);	// update the potential field
    navigator.spin();					// Run again!
    
    
    return 0;
}